; source for the controller-board (www.frydaysoft.de)
;----------------------------------------------------------------------

;----------------------------------------------------------------------
;put const-string to RS232
send_const_text:
	mov a,#0h
	movc a,@a+DPTR		     		;calculate text-index
	cjne a,#END_CH,send_to_rs232	;end of text ?
	ret
send_to_rs232:
	inc DPTR
	mov SBUF,a
	clr TI
	jnb TI,$
	jmp send_const_text

;--------------------------------------------
;init RS232
init_com:
	orl PCON,#80h      ; normal or faster processing
	orl SCON,#50h      ; SCON-Mode 1 (8Bit-UART) and REN 
	orl TCON,#40h      ; setze TR1 ->use TIMER1 (xxx1xxxx)
	orl TMOD,#20h      ; set 8Bit-auto-reload-TIMER0  (00100000)
	mov TH1,#baud      ; init Timer1 RS232
	mov TL1,#baud

	setb SM2
	clr TF1
	setb TR1
	clr ET1
    ;setb ES
	clr RI				;enable reveiving
	clr PS		   		;lower priority
	ret                


;################ Interrupts ###################

SIO_INT:
       push PSW
       jnb RI,Int_SIOExit
       clr RI
       ;push acc
       ;mov a,SBUF
       ;do something with accu
       ;pop acc
Int_SIOExit:
       pop PSW
        reti

;****************************************************************
