//#include "c:\ide51\c_bin\include\mcs51\8051.h"
#include "sio.h"


char cin(void) _naked
{
	_asm
CIN:
	 jnb RI,CIN	
 	 clr RI
     mov dpl,SBUF
     ret
	_endasm;
}

void cout(unsigned char c) _naked
{
	c;
	_asm  
	 mov SBUF,dpl
	 clr TI
COUT:		
	 jnb TI,COUT
	 ret
	_endasm;
}

void newLine(void)_naked
{
	_asm
		push dpl
	_endasm;

	cout(10);
	cout(13);
	_asm
		pop dpl
		ret
	_endasm;
}

void puts(unsigned char *ptr)
{
	ptr;
	if(!ptr) return;
	while(*ptr)			// print until null-terminated
	{
		cout(*ptr);
		ptr++;
	}
}

void putBin(unsigned char c)
{
	char mask=0x80;
	while(mask)
	{
		if (c&mask) cout('1'); 
		 else { cout('0'); }
		mask=mask>>1;			// shift mask
		mask=mask&0x7F;			// clear shifted carry
	};
}

void putHex(unsigned char c)
{
	char part=c;
	part=part>>4;
	part=part&0x0F;
	//HI
	if (part>9) part+=7;	// a..f
	cout(part+48);			// ASCII: 0..9 a..f
	//LO
	part=c&0x0F;
	if (part>9) part+=7;	// a..f
	cout(part+48);			// ASCII: 0..9 a..f
}
